//package com.sf.vertx.handle;
//
//import java.util.HashMap;
//import java.util.Map;
//import java.util.concurrent.TimeUnit;
//
//import org.springframework.data.redis.core.RedisTemplate;
//
//import com.sf.vertx.api.pojo.Strategy;
//import com.sf.vertx.constans.RedisKeyConfig;
//import com.sf.vertx.utils.SpringUtils;
//
//import cn.hutool.core.thread.ThreadUtil;
//import io.vertx.ext.web.RoutingContext;
//import lombok.extern.slf4j.Slf4j;
//
//@Slf4j
//public class RedisRateLimiter {
//	public Map<Integer, Boolean> acquire(RoutingContext rc, Strategy apiStrategy, Strategy appStrategy) {
//		String appCodeHeaderKey = rc.request().headers().get(AppConfigHandler.getAppCodeHeaderKey());
//		String key = null;
//		Map<Integer, Boolean> retMap = new HashMap<>();
//		if (apiStrategy != null) {
//			key = RedisKeyConfig.APP_CURRENT_LIMITING_CONFIG_KEY + ":" + appCodeHeaderKey + ":" + rc.request().uri()
//					+ ":" + rc.request().method();
//			Boolean ret = rateLimiter(key, appCodeHeaderKey, apiStrategy.getThreshold(), apiStrategy.getTimeWindow());
//			retMap.put(1, ret);
//		}
//
//		if (appStrategy != null) {
//			key = RedisKeyConfig.APP_CURRENT_LIMITING_CONFIG_KEY + ":" + appCodeHeaderKey;
//			Boolean ret = rateLimiter(key, appCodeHeaderKey, appStrategy.getThreshold(), appStrategy.getTimeWindow());
//			retMap.put(2, ret);
//		}
//		return retMap;
//	}
//
//	@SuppressWarnings("unchecked")
//	private Boolean rateLimiter(String key, String appCode, Integer threshold, Integer timeWindow) {
//		RedisTemplate<String, Integer> redisTemplate = SpringUtils.getBean("redisTemplate", RedisTemplate.class);
//		Integer count = redisTemplate.opsForValue().get(key);
//		// redisTemplate.delete(key);
//		log.info("redis limiter. key:{}, count:{}", key, count);
//		// 初始化,设置过期时间
//		ThreadUtil.execAsync(() -> {
//			increment(timeWindow, redisTemplate, key);
//		});
//		return (count == null || count <= threshold) ? true : false;
//	}
//	
//	private void increment(Integer timeWindow, RedisTemplate<String, Integer> redisTemplate, String key) {
//		Long incr = redisTemplate.opsForValue().increment(key);
//		if (incr == 1) { // 创建,才设置时间窗口
//			redisTemplate.expire(key, timeWindow, TimeUnit.SECONDS);
//		}
//	}
//}
