package com.sf.vertx.api.pojo;

import java.io.Serializable;
import java.util.List;

import lombok.Data;

@Data
public class ApiConfig implements Serializable {
	private static final long serialVersionUID = 5774283776114726263L;
	private String apiCode;
	private String uri;
	private String method; // 大写
	private Long timeout = 3000L; // 超时时间，单位毫秒
	private Integer mockDefaultHttpStatus;
	private String mockDefaultResponse;
	private List<Strategy> strategy; // 策略
	private List<MockExpectation> mockExpectations; // mock期望
}
